/**	DISPLAY.H
 *	Manage the display of the board and user moves
 */

#ifndef _DISPLAY_H
#define _DISPLAY_H

#include <stdlib.h>

#include "game.h" // cgame
#include "utils.h" // move

/**
 * @brief Displays the given board on screen
 * @param board: the board to display
 * @param rush_hour: is it a rush_hour game or âne rouge ? (exit position)
 */
void draw_board(cgame board, bool rush_hour);

/**
 * @brief Gets the user's next move
 * @return a move obejct representing the move
 */
move get_next_move(cgame board);

/**
 * @brief Prints a victory, displays score and pauses the game until user input
 */
void print_victory(cgame board);



/*	_DISPLAY_H_	*/
#endif 