#ifndef _UTILS_H_
#define _UTILS_H_

#include "piece.h"
#include "game.h"

/** Game **/

/**
 * @brief Test is the game is over (i.e. if the piece 0 has reached the exit).
 * @return true if the piece number 0 has coordinates (width/2,0).
 */

bool game_over_ar(cgame g);

/**	Move utils	**/

typedef struct move_s* move;

/**
 *@brief Creates a new move
 *@param pieceNum the piece number to be moved
 *@param d the direction to move the piece
 *@param distance the distance to move the piece
 */
move create_move(int pieceNum, dir d, int distance);

int get_move_piece(move m);
dir get_move_dir(move m);
int get_move_dist(move m);

/**
 *@brief deletes a move
 */
void delete_move(move m);


/** Sring utils */

/**
 *	@brief Recopies src into dst n times
 */
void string_mult(char* dst, const char* src, int n);

/** display utils */

/**
 *	@brief Read int into standard enter
 */

int read_int(char* c);

#endif
