#include <stdio.h>
#include <stdlib.h>

#include "display.h" 
#include "game.h"		//cgame
#include "piece.h"		//cpiece
#include "utils.h"		//move, is_small

/**    Pattern
    |*******|*******|*******|*******|*******|*******|
    |       |       |       |       |       |       |
    |   X   |   X   |   X   |   X   |   X   |   X   |
    |       |       |       |       |       |       |
    |*******|*******|*******|*******|*******|*******|
    |       |       |       |       |       |       |
    |   X   |   X   |   X   |   X   |   X   |   X   |
    |       |       |       |       |       |       |
    |*******|*******|*******|*******|*******|*******|
    |       |       |       |       |       |       
    |   0   |   0   |   X   |   X   |   X   |   X   
    |       |       |       |       |       |       
    |*******|*******|*******|*******|*******|*******|
    |       |       |       |       |       |       |
    |   X   |   X   |   X   |   X   |   X   |   X   |
    |       |       |       |       |       |       |
    |*******|*******|*******|*******|*******|*******|
    |       |       |       |       |       |       |
    |   X   |   X   |   X   |   X   |   X   |   X   |
    |       |       |       |       |       |       |
    |*******|*******|*******|*******|*******|*******|
    |       |       |       |       |       |       |
    |   X   |   X   |   X   |   X   |   X   |   X   |
    |       |       |       |       |       |       |
    |*******|*******|*******|*******|*******|*******| 
 */

void draw_board(cgame board, bool rush_hour) {
	//Emplacement de la sortie:
	int exit_x, exit_y;
	if(rush_hour) {
		exit_x = 5;
		exit_y = 3;
	}
	else {
		exit_x = (game_width(board)-1)/2;
		exit_y = -1; //On ne veut pas enlever de | en fin de ligne
	}

	//La longueure d'une ligne en charactère: |*******|*******|*******|*******|*******|*******|\n\0
	int lineSize = (8*game_width(board))+3; // en ajoutant dans la place pour le |, \n et \0

	//Gen chaines de charactères
	char* separateur = malloc(sizeof(char)*lineSize);
		separateur[0] = '|';
		separateur[1] = '\0';
		string_mult(separateur, "*******|", game_width(board)); // on ajoute n fois à la fin de la chaine
	char* vide = malloc((sizeof(char)*lineSize) + 1); //On rajoute une case pour le %c de la fin de la ligne %c = 2 chars
		vide[0] = '\0';
		string_mult(vide, "|       ", game_width(board));
		string_mult(vide, "%c\n", 1);
	char* fin = NULL;
	if (!rush_hour) {
		fin = malloc(sizeof(char)*lineSize);
			fin[0] = '|';
			fin[1] = '\0';
			string_mult(fin, "*******|", exit_x);
			string_mult(fin, "       |", 2);
			string_mult(fin, "*******|", game_width(board) - exit_x - 2);
	}
	else {
		fin = separateur;
	}

	for(int y = game_height(board) -1; y >= 0; y--){
		printf("%s\n", separateur);
		printf(vide, (y == exit_y) ? ' ' : '|');

		for (int x = 0; x < game_width(board); x++) {
			//*
			printf("|   %c   ", 
				(game_square_piece(board, x, y) == -1) ? ' ' : (char) (game_square_piece(board, x, y) + 48));
			//*/
		}
		printf("%c\n", (y == exit_y) ? ' ' : '|');
		printf(vide, (y == exit_y) ? ' ' : '|');
	}
	printf("%s\n\n\n", fin);

	free(separateur);
	free(vide);
	if (!rush_hour) free(fin);
}

void print_victory(cgame board) {
	printf("Victoire en %d mouvements, bravo !\n", game_nb_moves(board));
	/* Si un jour on arrive à faire ça
	printf("Appuyer sur entrée pour continuer\n");
	scanf("%c%c"); //Attend un retour ligne
	//*/
}

move get_next_move(cgame board) {
  int n, d, dist;

  n = read_int("Selectionner pièce : ");

  d = read_int("Direction (UP = 0, LEFT = 1, DOWN = 2, RIGHT = 3): ");

  dist = read_int("Distance : ");

  return create_move(n, d, dist);
}
