#include <stdio.h>
#include <stdbool.h>
#include <stdlib.h>

#include "display.h" 
#include "game.h"		//cgame
#include "piece.h"		//cpiece
#include "utils.h"

#define SIZE 4

piece* createPieceArray() {
	piece *t = malloc(sizeof(piece)*SIZE);
	t[0] = new_piece_rh(3, 3, true, true);
 	t[1] = new_piece_rh(3, 0, true, false);
 	t[2] = new_piece_rh(4, 1, true, true);
	t[3] = new_piece_rh(5, 3, false, false);
	return t;
}

void deleteArray(piece* t) {
	for (int i = 0; i < SIZE; i++) {
		delete_piece(t[i]);
	}
	free(t);
}

void print_move(move m) {
	printf("####Piece: %d; direction: %d; dist: %d\n", get_move_piece(m), get_move_dir(m), get_move_dist(m));
}

int main(void) {
	//*
	piece* array = createPieceArray();
	game board = new_game_hr(SIZE, array);
	draw_board(board, true);
	draw_board(board, false);

	move m = get_next_move(board);
	print_move(m);
	delete_move(m);

	print_victory(board);
	//*/
	deleteArray(array);
	delete_game(board);

	return EXIT_SUCCESS;
}