#include "piece.h"
#include <stdbool.h>
#include <stdio.h>
#include <stdlib.h>


struct piece_s {
  int x; //Abscisses
  int y; //Ordonnées
  int width;
  int height;
  bool move_x;
  bool move_y;
};
  
piece new_piece_rh (int x, int y, bool small, bool horizontal){
  int width, height;
  if (!horizontal)
    width = 1;
  else {
    if (small)
      width = 2;
    else
      width = 3;
  }
  if (horizontal)
    height = 1;
  else {
    if (small)
      height = 2;
    else
      height = 3;
  }
   return new_piece (x, y , width, height, horizontal, (!horizontal));
}

void delete_piece (piece p) {
  free(p);
}
//Copie des paramètres d'une pièce source vers une pièce de destination
void copy_piece (cpiece src, piece dst){
  dst->x = src->x;
  dst->y = src->y;
  dst->width = src->width;
  dst->height = src->height;
  dst->move_x = src->move_x;
  dst->move_y = src->move_y;
}

void move_piece(piece p, dir d, int distance){
  if ((d == UP || d == DOWN) && (p->move_y)){ //Condition pour que ce soit logique
    if (d == UP)//Condition pour savoir si on avance ou recule
      p->y += distance;
    else
      p->y -= distance;
  }
  else if ((d == LEFT || d == RIGHT) && (p->move_x)){ // Même chose
    if (d == RIGHT)
      p->x += distance;
    else
      p->x -= distance;
  }
}


bool intersect(cpiece p1,cpiece p2){
  int w1 = p1->width;
  int w2 = p2->width;
  int h1 = p1->height;
  int h2 = p2->height;
  for (int i=0; i<w1;i++){
    for (int j=0;j<h1;j++){
      for (int k=0;k<w2;k++){
        for (int l=0;l<h2;l++){
          if ((((p1->x)+i)==((p2->x)+k)) && (((p1->y)+j)==((p2->y)+l)))
            return true;
        }
      }
    }
  }
  return false;
}



int get_x(cpiece p){
  return p->x;
}

int get_y(cpiece p){
  return p->y;
}

bool is_horizontal(cpiece p){
  return (p->width > p->height);
}

int get_height(cpiece p){
	return p->height;
}

int get_width(cpiece p){
	return p->width;
}

piece new_piece(int x, int y, int width, int height, bool move_x, bool move_y){
  piece p = malloc (sizeof(struct piece_s)); //Création du pointeur de la nouvelle piece
  if (p == NULL){
    fprintf (stderr, "Problème d'allocation");
    exit(EXIT_FAILURE);
  }
  p->x = x;
  p->y = y;
  p->width = width;
  p->height = height;
  p->move_x = move_x;
  p->move_y = move_y;

  return p;
}
  
  
bool can_move_x(cpiece p){
  return (p->move_x);
}

bool can_move_y(cpiece p){
  return (p->move_y);
}


    
