#include <stdio.h>
#include <stdlib.h>

#include "display.h" 
#include "game.h"
#include "piece.h"
#include "utils.h"

int nb_pieces;
piece *tabpiece;



void set_up_lvl1(){
  	nb_pieces = 4;
  	piece *temp;
  	temp = realloc(tabpiece,nb_pieces*sizeof(piece));
  	if (temp == NULL){
  		free(tabpiece);
    	fprintf(stderr,"probleme de Reallocation\n");
    	exit(EXIT_FAILURE);
  	}
  	tabpiece=temp;
    tabpiece[0] = new_piece_rh(0, 3, true, true);
  	tabpiece[1] = new_piece_rh(3, 0, true, false);
  	tabpiece[2] = new_piece_rh(4, 1, true, true);
  	tabpiece[3] = new_piece_rh(5, 3, false, false);
}


void set_up_lvl2(){
    nb_pieces = 5;
    piece *temp;
    temp = realloc(tabpiece,nb_pieces*sizeof(piece));
    if (temp == NULL){
      free(tabpiece);
      fprintf(stderr,"probleme de Reallocation\n");
      exit(EXIT_FAILURE);
    }
    tabpiece=temp;
    tabpiece[0] = new_piece_rh(0, 3, true, true);
    tabpiece[1] = new_piece_rh(3, 3, false, false);
    tabpiece[2] = new_piece_rh(4, 3, false, false);
    tabpiece[3] = new_piece_rh(5, 3, false, false);
    tabpiece[4] = new_piece_rh(3, 2, false, true);
}



void tear_down_lvl() {
	for (int i = 0 ; i < nb_pieces; i++)
		delete_piece(tabpiece[i]);
}



// --------------------------------Version 2------------------------------
void set_up_anerouge_lvl1(){                                       //Tableau en 6 par 5
  	nb_pieces = 4;
  	piece *temp;
  	temp = realloc(tabpiece,nb_pieces*sizeof(piece));
  	if (temp == NULL){
  		free(tabpiece);
    	fprintf(stderr,"probleme de Reallocation\n");
    	exit(EXIT_FAILURE);
  	}
  	tabpiece=temp;
    tabpiece[0] = new_piece(2, 3, 2, 2, true, true);
  	tabpiece[1] = new_piece(3, 2, 2, 1, true, true);
  	tabpiece[2] = new_piece(1, 0, 2, 2, true, true);
  	tabpiece[3] = new_piece(0, 0, 1, 1, true, true);
}


void set_up_anerouge_lvl2(){                                    // Tableau en 4 par 5
    nb_pieces = 3;
    piece *temp;
    temp = realloc(tabpiece,nb_pieces*sizeof(piece));
    if (temp == NULL){
      free(tabpiece);
      fprintf(stderr,"probleme de Reallocation\n");
      exit(EXIT_FAILURE);
    }
    tabpiece=temp;
    tabpiece[0] = new_piece(1, 3, 2, 2, true, true);
    tabpiece[1] = new_piece(1, 2, 2, 1, true, true);
    tabpiece[2] = new_piece(0, 2, 1, 1, true, true);
}




//------------------- MAIN -----------------------//


int main(int argc, char *argv[]) {
  int jeu;

  do {
    jeu = read_int("rush hour (0) ou ane rouge (1) ?");
  } while (jeu < 0 || jeu > 1);

  if (jeu == 0) {
    set_up_lvl1();
    game g = new_game_hr(nb_pieces,tabpiece);
    while (!game_over_hr(g)){
      draw_board(g, true);
      move m = get_next_move(g);
      play_move(g,get_move_piece(m),get_move_dir(m),get_move_dist(m));
      delete_move(m);
    }
    print_victory(g);
    tear_down_lvl();
    delete_game(g);
    set_up_lvl2();
    game g2 = new_game_hr(nb_pieces,tabpiece);
    while (!game_over_hr(g2)){
      draw_board(g2, true);
      move m = get_next_move(g2);
      play_move(g2,get_move_piece(m),get_move_dir(m),get_move_dist(m));
      delete_move(m);
    }
    print_victory(g2);
    tear_down_lvl();
    delete_game(g2);
  }
  else {
    set_up_anerouge_lvl1();
    game g = new_game(6, 5, 4, tabpiece);
    while (!game_over_ar(g)){
      draw_board(g, false);
      move m = get_next_move(g);
      play_move(g,get_move_piece(m),get_move_dir(m),get_move_dist(m));
      delete_move(m);
    }
    print_victory(g);
    tear_down_lvl();
    delete_game(g);

    set_up_anerouge_lvl2();
    game g2 = new_game(4, 5, 3, tabpiece);
    while (!game_over_ar(g2)){
      draw_board(g2, false);
      move m = get_next_move(g2);
      play_move(g2,get_move_piece(m),get_move_dir(m),get_move_dist(m));
      delete_move(m);
    }
    print_victory(g2);
    tear_down_lvl();
    delete_game(g2);
  }
  
  return EXIT_SUCCESS;
}
