/**
 * Extra utils
 */

#include <stdio.h>
#include <stdlib.h>
#include <string.h>

#include "utils.h"
#include "piece.h"
#include "game.h"

struct move_s{
  int piece;
  dir d;
  int dist;
};


move create_move(int pieceNum, dir d, int distance){
  move m = malloc(sizeof(struct move_s));
  if ( m == NULL ){
      fprintf(stderr,"Problème d'allocation \n");
      exit(EXIT_FAILURE);
  }
  m->piece = pieceNum;
  m->d = d;
  m->dist = distance;
  return m;
}

void delete_move(move m){
  free(m);
}

int get_move_piece(move m) {
	return m->piece;
}

dir get_move_dir(move m){
	return m->d;
}

int get_move_dist(move m){
	return m->dist;
}

bool game_over_ar(cgame g){
  cpiece p = game_piece(g, 0);
  return (get_x(p)==(game_width(g)-1)/2 && get_y(p)==0);
}

void string_mult(char* dst, const char* src, int n){
	for(int i = 0; i < n; i++){
		strcat(dst, src);
	}
}

int read_int(char* c){
  int n, r;
  int b_size = 30;
  char buffer[b_size];

  printf ("%s", c);
  fgets(buffer, b_size, stdin);
  r = sscanf(buffer, "%d", &n);
  while (r < 1) {
    printf("\nErreur! %s", c);
    fgets(buffer, b_size, stdin);
    r = sscanf(buffer, "%d", &n);
  }
  return n;
}
